## SVG Surfaces

SVG Surfaces — Rendering SVG documents

## Functions

cairo_surface_t * | cairo_svg_surface_create ()
cairo_surface_t * | cairo_svg_surface_create_for_stream ()
void | cairo_svg_surface_restrict_to_version ()
void | cairo_svg_get_versions ()
const char * | cairo_svg_version_to_string ()

## Types and Values

#define | CAIRO_HAS_SVG_SURFACE
enum | cairo_svg_version_t

## Description

The SVG surface is used to render cairo graphics to SVG files and is a multi-page vector surface backend.

## Functions

### cairo_svg_surface_create ()

    cairo_surface_t *
    cairo_svg_surface_create (const char *filename,
                              double width_in_points,
                              double height_in_points);

Creates a SVG surface of the specified size in points to be written to `filename` .

The SVG surface backend recognizes the following MIME types for the data attached to a surface (see `cairo_surface_set_mime_data()`) when it is used as a source pattern for drawing on this surface: `CAIRO_MIME_TYPE_JPEG`, `CAIRO_MIME_TYPE_PNG`, `CAIRO_MIME_TYPE_URI`. If any of them is specified, the SVG backend emits a href with the content of MIME data instead of a surface snapshot (PNG, Base64-encoded) in the corresponding image tag.

The unofficial MIME type `CAIRO_MIME_TYPE_URI` is examined first. If present, the URI is emitted as is: assuring the correctness of URI is left to the client code.

If `CAIRO_MIME_TYPE_URI` is not present, but `CAIRO_MIME_TYPE_JPEG` or `CAIRO_MIME_TYPE_PNG` is specified, the corresponding data is Base64-encoded and emitted.

#### Parameters

filename | a filename for the SVG output (must be writable), `NULL` may be used to specify no output. This will generate a SVG surface that may be queried and used as a source, without generating a temporary file. |
width_in_points | width of the surface, in points (1 point == 1/72.0 inch) |
height_in_points | height of the surface, in points (1 point == 1/72.0 inch) |

#### Returns

a pointer to the newly created surface. The caller owns the surface and should call `cairo_surface_destroy()` when done with it.

This function always returns a valid pointer, but it will return a pointer to a "nil" surface if an error such as out of memory occurs. You can use `cairo_surface_status()` to check for this.

Since: 1.2

### cairo_svg_surface_create_for_stream ()

    cairo_surface_t *
    cairo_svg_surface_create_for_stream (cairo_write_func_t write_func,
                                         void *closure,
                                         double width_in_points,
                                         double height_in_points);

Creates a SVG surface of the specified size in points to be written incrementally to the stream represented by `write_func` and `closure` .

#### Parameters

write_func | a cairo_write_func_t to accept the output data, may be `NULL` to indicate a no-op `write_func` . With a no-op `write_func` , the surface may be queried or used as a source without generating any temporary files. |
closure | the closure argument for `write_func` |
width_in_points | width of the surface, in points (1 point == 1/72.0 inch) |
height_in_points | height of the surface, in points (1 point == 1/72.0 inch) |

#### Returns

a pointer to the newly created surface. The caller owns the surface and should call `cairo_surface_destroy()` when done with it.

This function always returns a valid pointer, but it will return a pointer to a "nil" surface if an error such as out of memory occurs. You can use `cairo_surface_status()` to check for this.

Since: 1.2

### cairo_svg_surface_restrict_to_version ()

    void
    cairo_svg_surface_restrict_to_version (cairo_surface_t *surface,
                                           cairo_svg_version_t version);

Restricts the generated SVG file to `version` . See `cairo_svg_get_versions()` for a list of available version values that can be used here.

This function should only be called before any drawing operations have been performed on the given surface. The simplest way to do this is to call this function immediately after creating the surface.

#### Parameters

surface | a SVG cairo_surface_t |
version | SVG version |

Since: 1.2

### cairo_svg_get_versions ()

    void
    cairo_svg_get_versions (cairo_svg_version_t const **versions,
                            int *num_versions);

Used to retrieve the list of supported versions. See `cairo_svg_surface_restrict_to_version()`.

#### Parameters

versions | supported version list |
num_versions | list length |

Since: 1.2

### cairo_svg_version_to_string ()

    const char *
    cairo_svg_version_to_string (cairo_svg_version_t version);

Get the string representation of the given `version` id. This function will return `NULL` if `version` isn't valid. See `cairo_svg_get_versions()` for a way to get the list of valid version ids.

#### Parameters

version | a version id |

#### Returns

the string associated to given version.

Since: 1.2

## Types and Values

### CAIRO_HAS_SVG_SURFACE

    #define CAIRO_HAS_SVG_SURFACE 1

Defined if the SVG surface backend is available. This macro can be used to conditionally compile backend-specific code.

Since: 1.2

### enum cairo_svg_version_t

cairo_svg_version_t is used to describe the version number of the SVG specification that a generated SVG file will conform to.

#### Members

CAIRO_SVG_VERSION_1_1 | The version 1.1 of the SVG specification. (Since 1.2) |
CAIRO_SVG_VERSION_1_2 | The version 1.2 of the SVG specification. (Since 1.2) |

Since: 1.2

## See Also

cairo_surface_t